{$WARNINGS OFF}
//=============================================================================
//  FileSystemObjectgpĎwt@C̏擾ĕ\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2009N0201 J
//  2013N0217 R[hWindows 7 U64(SP1) + Delphi XE œmF
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit FileInfoUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Scripting_TLB, ComObj;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    Panel2: TPanel;
    ChkBox1: TCheckBox;
    ChkBox2: TCheckBox;
    ChkBox3: TCheckBox;
    ChkBox4: TCheckBox;
    LblEdit1: TLabeledEdit;
    LblEdit2: TLabeledEdit;
    LblEdit3: TLabeledEdit;
    LblEdit5: TLabeledEdit;
    LblEdit6: TLabeledEdit;
    LblEdit7: TLabeledEdit;
    LblEdit4: TLabeledEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    FFileSystem : IFileSystem3;
    FFileObjet  : IFile;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  t@CVXeIuWFNg(IFileSystem)
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  FFileSystem := CoFileSystemObject.Create;

  Button2.Enabled := False;
end;

//=============================================================================
//  IuWFNgnil
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(FFileSystem) then FFileSystem := nil;
  if Assigned(FFileObjet)  then FFileObjet  := nil;
end;

//=============================================================================
//  t@CIď擾
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LFileSize   : Int64;
  LAttrib     : Integer;
  LDateFormat : String;
begin
  OpenDialog1.OptionsEx  := [];
  OpenDialog1.FileName   := '';

  if OpenDialog1.Execute then begin
    //t@CIuWFNg(IFile)
    FFileObjet := FFileSystem.GetFile(OpenDialog1.FileName);

    LblEdit1.Text := '';
    LblEdit2.Text := '';
    LblEdit3.Text := '';
    LblEdit4.Text := '';
    LblEdit5.Text := '';
    LblEdit6.Text := '';
    LblEdit7.Text := '';

    //It@C̃tpX
    LblEdit1.Text := FFileObjet.Path;
    //t@C
    LblEdit2.Text := FFileObjet.Name;
    //t@C
    LblEdit3.Text := FFileObjet.type_;
    //t@C
    LblEdit3.Text := FFileObjet.type_;
    //TCY
    LFileSize     := FFileObjet.Size / 1024;
    LblEdit4.Text := FormatFloat('###,##0 KB', LFileSize);
    //쐬
    LDateFormat   := 'yyyy/mm/dd hh:nn:ss';
    LblEdit5.Text := FormatDateTime(LDateFormat, FFileObjet.DateCreated);
    //XV
    LblEdit6.Text := FormatDateTime(LDateFormat, FFileObjet.DateLastModified);
    //ŏIANZX
    LblEdit7.Text := FormatDateTime(LDateFormat, FFileObjet.DateLastAccessed);

    //
    LAttrib := FFileObjet.Attributes;
    ChkBox1.Checked := Bool(LAttrib and FILE_ATTRIBUTE_READONLY);
    ChkBox2.Checked := Bool(LAttrib and FILE_ATTRIBUTE_HIDDEN);
    ChkBox3.Checked := Bool(LAttrib and FILE_ATTRIBUTE_SYSTEM);
    ChkBox4.Checked := Bool(LAttrib and FILE_ATTRIBUTE_ARCHIVE);

    Button2.Enabled := True;
  end;
end;

//=============================================================================
//  t@C̕ύX(̂)
//  t@C̓֌W͓ǂݏopƕύXłȂ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LOldFileName : String;
  LOldAttrib   : Cardinal;
  LNewAttrib   : Cardinal;
begin
  if FFileObjet = nil then exit;

  LOldFileName := FFileObjet.Name;

  //t@C̕ύX.ύXȂ΍XVȂ悤ɂ
  LOldAttrib := FFileObjet.Attributes;
  LNewAttrib := LOldAttrib;
  //Ǐop
  if ChkBox1.Checked then begin
    if (LNewAttrib and FILE_ATTRIBUTE_READONLY) = 0 then begin
      LNewAttrib := LNewAttrib or FILE_ATTRIBUTE_READONLY;
    end;
  end else begin
    if (LNewAttrib and FILE_ATTRIBUTE_READONLY) <> 0 then begin
      LNewAttrib := LNewAttrib xor FILE_ATTRIBUTE_READONLY;
    end;
  end;
  //B
  if ChkBox2.Checked then begin
    if (LNewAttrib and FILE_ATTRIBUTE_HIDDEN) = 0 then begin
      LNewAttrib := LNewAttrib or  FILE_ATTRIBUTE_HIDDEN;
    end;
  end else begin
    if (LNewAttrib and FILE_ATTRIBUTE_HIDDEN) <> 0 then begin
      LNewAttrib := LNewAttrib xor FILE_ATTRIBUTE_HIDDEN;
    end;
  end;
  if (LOldAttrib and LNewAttrib) <> 0 then begin
    FFileObjet.Attributes := LNewAttrib;
  end;

  //tH_̖OύX
  if LOldFileName <> LblEdit2.Text then begin
    FFileObjet.Name := LblEdit2.Text;
    LblEdit1.Text   := FFileObjet.Path;
  end;
end;

end.
