{$WARNINGS OFF}
//=============================================================================
//  FileSystemObjectgpĎwtH_̏擾ĕ\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2009N0201 J
//  2013N0217 R[hWindows 7 U64(SP1) + Delphi XE œmF
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit FoldderInfoUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Scripting_TLB, ComObj;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    ChkBox1: TCheckBox;
    ChkBox2: TCheckBox;
    ChkBox3: TCheckBox;
    ChkBox4: TCheckBox;
    LblEdit1: TLabeledEdit;
    LblEdit2: TLabeledEdit;
    LblEdit3: TLabeledEdit;
    LblEdit4: TLabeledEdit;
    LblEdit5: TLabeledEdit;
    LblEdit6: TLabeledEdit;
    LblEdit7: TLabeledEdit;
    LblEdit8: TLabeledEdit;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    FFileSystem   : IFileSystem3;
    FFolderObject : IFolder;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses FileCtrl, ActiveX;

{$R *.dfm}

//=============================================================================
//  t@CVXeIuWFNg(IFileSystem)
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
begin
  FFileSystem := CoFileSystemObject.Create;

  Button2.Enabled := False;
end;

//=============================================================================
//  IuWFNgnil
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(FFileSystem)   then FFileSystem   := nil;
  if Assigned(FFolderObject) then FFolderObject := nil;
end;

//=============================================================================
//  tH_Iď擾
//  SelectDirectory̎gpɂusesFileCtrlKv
//
//  t@C̗񋓂eXgĂ݂񋓂ɂ͌ĂȂ̂mȂ
//  VXe֌W̃t@C̎擾ɂ͎sꍇ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LBasePath   : String;
  LFolderSize : Int64;
  LFineCount  : Integer;
  LAttrib     : Cardinal;
  LDateFormat : String;
  LEnumRow    : IEnumVariant;
  LRowObj     : OleVariant;
  LValue      : Cardinal;
  i           : Integer;
begin
  if SelectDirectory('ΏۃtH_I', '', LBasePath, []) then begin
    Button1.Enabled := False;
    Button2.Enabled := False;

    //t@CIuWFNg(IFile)
    FFolderObject := FFileSystem.GetFolder(LBasePath);
    //hCuw肷Ƌ(dl?)
    if FFolderObject.Name = '' then exit;

    LblEdit1.Text := '';
    LblEdit2.Text := '';
    LblEdit3.Text := '';
    LblEdit4.Text := '';
    LblEdit5.Text := '';
    LblEdit6.Text := '';
    LblEdit7.Text := '';

    //It@C̃tpX
    LblEdit1.Text := FFolderObject.Path;
    //t@C
    LblEdit2.Text := FFolderObject.Name;
    //t@C
    LblEdit3.Text := FFolderObject.type_;
    //TCY
    LFolderSize   := FFolderObject.Size / 1024;
    LblEdit4.Text := FormatFloat('###,##0 KB', LFolderSize);
    //t@C(tH_܂)
    LFineCount    := FFolderObject.Files.Count+FFolderObject.SubFolders.Count;
    LblEdit5.Text := FormatFloat('###,##0 ', LFineCount);
    //쐬
    LDateFormat   := 'yyyy/mm/dd hh:nn:ss';
    LblEdit6.Text := FormatDateTime(LDateFormat, FFolderObject.DateCreated);
    //XV
    LblEdit7.Text := FormatDateTime(LDateFormat, FFolderObject.DateLastModified);
    //ANZX
    LblEdit8.Text := FormatDateTime(LDateFormat, FFolderObject.DateLastAccessed);

    //
    LAttrib := FFolderObject.Attributes;
    ChkBox1.Checked := Bool(LAttrib and FILE_ATTRIBUTE_READONLY);
    ChkBox2.Checked := Bool(LAttrib and FILE_ATTRIBUTE_HIDDEN);
    ChkBox3.Checked := Bool(LAttrib and FILE_ATTRIBUTE_SYSTEM);
    ChkBox4.Checked := Bool(LAttrib and FILE_ATTRIBUTE_ARCHIVE);

    //Xg{bNX̃tH_̃t@CXg
    //TutH_t@CƎԂ邪,ētH_
    //w肷Ƃ(LbV̂?)
    Screen.Cursor := crHourGlass;
    ListBox1.Items.Clear;
    ListBox1.Items.BeginUpdate;

    //tH_IuWFNg(Enum)
    LEnumRow := FFolderObject.Files._NewEnum as IEnumVariant;
    for i := 0 to FFolderObject.Files.Count - 1 do begin
      //1o
      //Value̖߂l0ȉł΂Ȃ
      //RowObjIFileIuWFNg
      LEnumRow.Next(1, LRowObj, LValue);
      if LValue <= 0 then break;

      ListBox1.Items.Add(LRowObj.Name);
      Application.ProcessMessages;
    end;
    ListBox1.Items.EndUpdate;
    Screen.Cursor := crDefault;

    Button1.Enabled := True;
    Button2.Enabled := True;
  end;
end;

//=============================================================================
//  tH_̖OƑύX
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LOldfileName : String;
  LOldAttrib   : Cardinal;
  LNewAttrib   : Cardinal;
begin
  if FFolderObject = nil then exit;

  LOldfileName := FFolderObject.Name;

  //t@C̕ύX.ύXȂ΍XVȂ悤ɂ
  LOldAttrib := FFolderObject.Attributes;
  LNewAttrib := LOldAttrib;
  //Ǐop
  if ChkBox1.Checked then begin
    if (LNewAttrib and FILE_ATTRIBUTE_READONLY) = 0 then begin
      LNewAttrib := LNewAttrib or FILE_ATTRIBUTE_READONLY;
    end;
  end else begin
    if (LNewAttrib and FILE_ATTRIBUTE_READONLY) <> 0 then begin
      LNewAttrib := LNewAttrib xor FILE_ATTRIBUTE_READONLY;
    end;
  end;
  //B
  if ChkBox2.Checked then begin
    if (LNewAttrib and FILE_ATTRIBUTE_HIDDEN) = 0 then begin
      LNewAttrib := LNewAttrib or  FILE_ATTRIBUTE_HIDDEN;
    end;
  end else begin
    if (LNewAttrib and FILE_ATTRIBUTE_HIDDEN) <> 0 then begin
      LNewAttrib := LNewAttrib xor FILE_ATTRIBUTE_HIDDEN;
    end;
  end;
  if (LOldAttrib and LNewAttrib) <> 0 then begin
    FFolderObject.Attributes := LNewAttrib;
  end;

  //tH_̖OύX
  if LOldfileName <> LblEdit2.Text then begin
    FFolderObject.Name := LblEdit2.Text;
    LblEdit1.Text      := FFolderObject.Path;
  end;
end;

end.
